Index: /XIOS/trunk/src/transformation/generic_algorithm_transformation.cpp
===================================================================
--- /XIOS/trunk/src/transformation/generic_algorithm_transformation.cpp	(revision 1536)
+++ /XIOS/trunk/src/transformation/generic_algorithm_transformation.cpp	(revision 1537)
@@ -647,4 +838,295 @@
   }
 }
+
+
+
+
+
+
+void CGenericAlgorithmTransformation::computeTransformationMappingNonDistributed(int elementPositionInGrid, CGrid* gridSrc, CGrid* gridDst,
+                                                                                 vector<int>& localSrc, vector<int>& localDst, vector<double>& weight, vector<bool>& localMaskOnGridDest)
+{
+
+  CContext* context = CContext::getCurrent();
+  CContextClient* client = context->client;
+  int nbClient = client->clientSize;
+
+  computePositionElements(gridDst, gridSrc);
+  std::vector<CScalar*> scalarListDstP = gridDst->getScalars();
+  std::vector<CAxis*> axisListDstP = gridDst->getAxis();
+  std::vector<CDomain*> domainListDstP = gridDst->getDomains();
+  CArray<int,1> axisDomainDstOrder = gridDst->axis_domain_order;
+  std::vector<CScalar*> scalarListSrcP  = gridSrc->getScalars();
+  std::vector<CAxis*> axisListSrcP = gridSrc->getAxis();
+  std::vector<CDomain*> domainListSrcP = gridSrc->getDomains();
+  CArray<int,1> axisDomainSrcOrder = gridSrc->axis_domain_order;  
+
+  int nElement=axisDomainSrcOrder.numElements() ;
+  int indSrc=1 ;
+  int indDst=1 ;
+  vector<int> nIndexSrc(nElement) ;
+  vector<int> nIndexDst(nElement) ;
+  vector< CArray<bool,1>* > maskSrc(nElement) ;
+  vector< CArray<bool,1>* > maskDst(nElement) ;
+    
+  int nlocalIndexSrc=1 ;
+  int nlocalIndexDest=1 ;
+  CArray<bool,1> maskScalar(1) ;
+  maskScalar  = true ;
+  
+  
+  for(int i=0 ; i<nElement; i++)
+  {
+    int dimElement = axisDomainSrcOrder(i);
+    if (2 == dimElement) //domain
+    {
+      CDomain* domain=domainListSrcP[elementPositionInGridSrc2DomainPosition_[i]] ;
+      nIndexSrc[i] = domain->i_index.numElements() ;
+      maskSrc[i]=&domain->localMask ;
+    }
+    else if (1 == dimElement) //axis
+    {
+      CAxis* axis=axisListSrcP[elementPositionInGridSrc2AxisPosition_[i]] ;
+      nIndexSrc[i] = axis->index.numElements() ;
+      maskSrc[i]=&axis->mask ;
+    }
+    else  //scalar
+    {
+      nIndexSrc[i]=1 ;
+      maskSrc[i]=&maskScalar ;
+    }
+    nlocalIndexSrc=nlocalIndexSrc*nIndexSrc[i] ;
+  }
+
+
+
+  int offset=1 ;
+  for(int i=0 ; i<nElement; i++)
+  {
+    int dimElement = axisDomainDstOrder(i);
+    if (2 == dimElement) //domain
+    {
+      CDomain* domain=domainListDstP[elementPositionInGridDst2DomainPosition_[i]] ;
+      int nIndex=domain->i_index.numElements() ;
+      CArray<bool,1>& localMask=domain->localMask ;
+      int nbInd=0 ;
+      for(int j=0;j<nIndex;j++) if (localMask(j)) nbInd++ ;
+      nIndexDst[i] = nbInd ;
+      maskDst[i]=&domain->localMask ;
+    }
+    else if (1 == dimElement) //axis
+    {
+      CAxis* axis = axisListDstP[elementPositionInGridDst2AxisPosition_[i]] ;
+      int nIndex=axis->index.numElements() ;
+      CArray<bool,1>& localMask=axis->mask ;
+      int nbInd=0 ;
+      for(int j=0;j<nIndex;j++) if (localMask(j)) nbInd++ ;
+      nIndexDst[i] = nbInd ;
+      maskDst[i]=&axis->mask ;
+    }
+    else  //scalar
+    {
+      nIndexDst[i]=1 ;
+      maskDst[i]=&maskScalar ;
+    }
+    if (i<elementPositionInGrid) offset=offset*nIndexDst[i] ;
+    nlocalIndexDest=nlocalIndexDest*nIndexDst[i] ;
+  }
+
+
+
+
+
+
+  vector<int> dstLocalInd ;
+  int dimElement = axisDomainDstOrder(elementPositionInGrid);
+  if (2 == dimElement) //domain
+  {
+    CDomain* domain = domainListDstP[elementPositionInGridDst2DomainPosition_[elementPositionInGrid]] ;
+    int ni_glo=domain->ni_glo ;
+    int nj_glo=domain->nj_glo ;
+    int nindex_glo=ni_glo*nj_glo ;
+    dstLocalInd.resize(nindex_glo,-1) ;
+    int nIndex=domain->i_index.numElements() ;
+    CArray<bool,1>& localMask=domain->localMask ;
+    int unmaskedInd=0 ;
+    int globIndex ;
+    for(int i=0;i<nIndex;i++)
+    {
+      if (localMask(i))
+      {
+        globIndex=domain->j_index(i)*ni_glo+domain->i_index(i) ;
+        dstLocalInd[globIndex]=unmaskedInd ;
+        unmaskedInd++ ;
+      }
+    }
+  }
+  else if (1 == dimElement) //axis
+  {
+    CAxis* axis = axisListDstP[elementPositionInGridDst2AxisPosition_[elementPositionInGrid]] ;
+    int nindex_glo=axis->n_glo ;
+    dstLocalInd.resize(nindex_glo,-1) ;
+    int nIndex=axis->index.numElements() ;
+    CArray<bool,1>& localMask=axis->mask ; // axis mask must include later data_index
+    int unmaskedInd=0 ;
+    for(int i=0;i<nIndex;i++)
+    {
+      if (localMask(i))
+      {
+        dstLocalInd[axis->index(i)]=unmaskedInd ;
+        unmaskedInd++ ;
+      }
+    }
+  }
+  else  //scalar
+  {
+    dstLocalInd.resize(1) ; 
+    dstLocalInd[0]=0 ; 
+  }
+
+// just get the local src mask
+  CArray<bool,1> localMaskOnSrcGrid;
+  gridSrc->getLocalMask(localMaskOnSrcGrid) ;
+// intermediate grid, mask is not initialized => set up mask to true
+  if (localMaskOnSrcGrid.isEmpty())
+  {
+    localMaskOnSrcGrid.resize(nlocalIndexSrc) ;
+    localMaskOnSrcGrid=true ;
+  }
+  
+
+  localMaskOnGridDest.resize(nlocalIndexDest,false) ;
+
+  vector<vector<vector<pair<int,double> > > > dstIndWeight(transformationMapping_.size()) ;
+   
+  for(int t=0;t<transformationMapping_.size();++t)
+  {
+    TransformationIndexMap::const_iterator   itTransMap = transformationMapping_[t].begin(),
+                                             iteTransMap = transformationMapping_[t].end();
+    TransformationWeightMap::const_iterator itTransWeight = transformationWeight_[t].begin();
+    dstIndWeight[t].resize(nIndexSrc[elementPositionInGrid]) ;
+    
+    for(;itTransMap!=iteTransMap;++itTransMap,++itTransWeight)
+    {
+      int dst=dstLocalInd[itTransMap->first] ;
+      if (dst!=-1)
+      {
+        const vector<int>& srcs=itTransMap->second;
+        const vector<double>& weights=itTransWeight->second;
+        for(int i=0;i<srcs.size() ;i++) dstIndWeight[t][srcs[i]].push_back(pair<int,double>(dst*offset+t,weights[i])) ;
+      }
+    }
+  }
+  int srcInd=0 ;  
+  int currentInd ;
+  int t=0 ;  
+  int srcIndCompressed=0 ;
+  
+  nonDistributedrecursiveFunct(nElement-1,true,elementPositionInGrid,maskSrc,maskDst, srcInd, srcIndCompressed, nIndexSrc, t, dstIndWeight,  
+                               currentInd,localSrc,localDst,weight, localMaskOnSrcGrid, localMaskOnGridDest );
+               
+}
+
+
+void CGenericAlgorithmTransformation::nonDistributedrecursiveFunct(int currentPos, bool masked, int elementPositionInGrid, vector< CArray<bool,1>* >& maskSrc, vector< CArray<bool,1>* >& maskDst, int& srcInd, int& srcIndCompressed, vector<int>& nIndexSrc, int& t, vector<vector<vector<pair<int,double> > > >& dstIndWeight, int currentInd,
+                    vector<int>& localSrc, vector<int>& localDst, vector<double>& weight,  CArray<bool,1>& localMaskOnGridSrc, vector<bool>& localMaskOnGridDest )
+{
+  int masked_ ;
+  if (currentPos!=elementPositionInGrid)
+  {
+    if (currentPos!=0)
+    {
+      CArray<bool,1>& mask = *maskSrc[currentPos] ;
+     
+      for(int i=0;i<nIndexSrc[currentPos];i++)
+      {
+        masked_=masked ;
+        if (!mask(i)) masked_=false ;
+        nonDistributedrecursiveFunct(currentPos-1, masked_, elementPositionInGrid, maskSrc, maskDst, srcInd, srcIndCompressed, nIndexSrc, t, dstIndWeight, currentInd, localSrc, localDst, weight, localMaskOnGridSrc, localMaskOnGridDest) ;
+      }
+    }
+    else
+    {
+      CArray<bool,1>& mask = *maskSrc[currentPos] ;
+      for(int i=0;i<nIndexSrc[currentPos];i++)
+      {
+        if (masked && mask(i))
+        {
+          if (dstIndWeight[t][currentInd].size()>0)
+          {
+            for(vector<pair<int,double> >::iterator it = dstIndWeight[t][currentInd].begin(); it!=dstIndWeight[t][currentInd].end(); ++it)
+            {
+              if (localMaskOnGridSrc(srcInd))
+              {
+                localSrc.push_back(srcIndCompressed) ;
+                localDst.push_back(it->first) ;
+                weight.push_back(it->second) ;
+                localMaskOnGridDest[it->first]=true ;
+              }
+              (it->first)++ ;
+            }
+          }
+          if (t < dstIndWeight.size()-1) t++ ;
+          if (localMaskOnGridSrc(srcInd)) srcIndCompressed ++ ;
+        }
+        srcInd++ ;
+      }
+    }
+  }
+  else
+  {
+ 
+    if (currentPos!=0)
+    {
+
+      CArray<bool,1>& mask = *maskSrc[currentPos] ;
+      for(int i=0;i<nIndexSrc[currentPos];i++)
+      {
+        t=0 ;
+        masked_=masked ;
+        if (!mask(i)) masked_=false ; 
+        nonDistributedrecursiveFunct(currentPos-1, masked_, elementPositionInGrid, maskSrc, maskDst, srcInd, srcIndCompressed, nIndexSrc, t, dstIndWeight , i,  localSrc, localDst, weight, localMaskOnGridSrc, localMaskOnGridDest) ;
+      }
+    }
+    else
+    {
+      for(int i=0;i<nIndexSrc[currentPos];i++)
+      {
+        if (masked)
+        {
+          t=0 ;        
+          if (dstIndWeight[t][i].size()>0)
+          {
+            for(vector<pair<int,double> >::iterator it = dstIndWeight[t][i].begin(); it!=dstIndWeight[t][i].end(); ++it)
+            {
+              if (localMaskOnGridSrc(srcInd))
+              {
+                localSrc.push_back(srcIndCompressed) ;
+                localDst.push_back(it->first) ;
+                weight.push_back(it->second) ;
+                localMaskOnGridDest[it->first]=true ;
+              }
+              (it->first)++ ;
+            }
+           }
+          if (t < dstIndWeight.size()-1) t++ ;
+          if (localMaskOnGridSrc(srcInd)) srcIndCompressed ++ ;
+        }
+        srcInd++ ;
+      }
+    }
+  }
+
+}
+
+
+
+
+
+
+
+
+
+
 
 /*!
Index: /XIOS/trunk/src/transformation/generic_algorithm_transformation.hpp
===================================================================
--- /XIOS/trunk/src/transformation/generic_algorithm_transformation.hpp	(revision 1536)
+++ /XIOS/trunk/src/transformation/generic_algorithm_transformation.hpp	(revision 1537)
@@ -52,4 +52,6 @@
   virtual ~CGenericAlgorithmTransformation() {}
 
+  bool isDistributedTransformation(int elementPositionInGrid, CGrid* gridSrc, CGrid* gridDst) ;
+
   void computeGlobalSourceIndex(int elementPositionInGrid,
                                CGrid* gridSrc,
@@ -85,4 +87,8 @@
   */
   void computeIndexSourceMapping(const std::vector<CArray<double,1>* >& dataAuxInputs = std::vector<CArray<double,1>* >());
+  void computeTransformationMappingNonDistributed(int elementPositionInGrid, CGrid* gridSrc, CGrid* gridDst,
+                                                  vector<int>& localSrc, vector<int>& localDst, vector<double>& weight, vector<bool>& localMaskOnGridDest);
+  void nonDistributedrecursiveFunct(int currentPos, bool masked, int elementPositionInGrid,  vector< CArray<bool,1>* >& maskSrc, vector< CArray<bool,1>* >& maskDst, int& srcInd, int& srcIndCompressed, vector<int>& nIndexSrc, int& t, vector<vector<vector<pair<int,double> > > >& dstIndWeight, int currentInd,
+                                     vector<int>& localSrc, vector<int>& localDst, vector<double>& weight, CArray<bool,1>& localMaskOnGridSrc, vector<bool>& localMaskOnGridDest) ;
 
 protected:
@@ -126,4 +132,9 @@
 
 protected:
+  //! indicate if the transformation is performed on a distributed element
+  bool isDistributed_ ;
+  //! indicate if the method  isDistributedTransformation has been called before
+  bool isDistributedComputed_ ;
+  
   //! Map between global index of destination element and source element
   std::vector<TransformationIndexMap> transformationMapping_;
@@ -138,6 +149,22 @@
   AlgoTransType type_;
 
+  std::set<StdSize> indexElementSrc_;
+
+  std::vector<boost::unordered_map<int,std::vector<size_t> > > globalElementIndexOnProc_;
+
+  std::vector<int> procContainSrcElementIdx_;  // List of processes containing source index of transformed elements
+//  std::set<int> procOfNonTransformedElements_; // Processes contain the source index of non-transformed elements
+  std::set<int> commonProc_;
+  std::vector< set<int> > procElementList_ ; // List of processes containing source index of elements
+
+  CClientClientDHTInt::Index2VectorInfoTypeMap globalIndexOfTransformedElementOnProc_;
+  
+  bool computedProcSrcNonTransformedElement_; // Flag to indicate whether we computed proc containing non transformed elements
+
   std::map<int, int> elementPositionInGridSrc2AxisPosition_, elementPositionInGridSrc2DomainPosition_, elementPositionInGridSrc2ScalarPosition_;
   std::map<int, int> elementPositionInGridDst2AxisPosition_, elementPositionInGridDst2DomainPosition_, elementPositionInGridDst2ScalarPosition_;
+
+  bool eliminateRedondantSrc_ ; // flag to indicate if the transformation must select only one global source point for all proc.
+                               // In this case it will choose preferentially the current process 
 };
 
Index: /XIOS/trunk/src/transformation/grid_transformation.cpp
===================================================================
--- /XIOS/trunk/src/transformation/grid_transformation.cpp	(revision 1536)
+++ /XIOS/trunk/src/transformation/grid_transformation.cpp	(revision 1537)
@@ -16,4 +16,5 @@
 #include "grid.hpp"
 #include <boost/unordered_map.hpp>
+#include "timer.hpp"
 
 namespace xios {
@@ -385,16 +386,62 @@
         (CGenericAlgorithmTransformation::ELEMENT_MODIFICATION_WITH_DATA == algo->type()))) // Only registered transformation can be executed
     {
+      CTimer::get("computeIndexSourceMapping").resume() ;
       algo->computeIndexSourceMapping(dataAuxInputs);
-
+      CTimer::get("computeIndexSourceMapping").suspend() ;
+      
       // ComputeTransformation of global index of each element
       int elementPosition = it->first;
-      algo->computeGlobalSourceIndex(elementPosition,
-                                     gridSource_,
-                                     tmpGridDestination_,
-                                     globaIndexWeightFromSrcToDst);
-
-      // Compute transformation of global indexes among grids
-      computeTransformationMapping(globaIndexWeightFromSrcToDst);
-
+      bool nonDistributedActivated = CXios::getin<bool>("activate_non_distributed_transformation",false);
+      
+      if (nonDistributedActivated && !algo->isDistributedTransformation(elementPositionInGrid, gridSource_, tmpGridDestination_) )
+      {
+        vector<int> localSrc ;
+        vector<int> localDst ;
+        vector<double> weight ;
+        localMaskOnGridDest_.push_back(vector<bool>()) ;
+        CTimer::get("computeTransformationMappingNonDistributed").resume();  
+        algo->computeTransformationMappingNonDistributed(elementPosition, gridSource_, tmpGridDestination_, 
+                                                         localSrc, localDst, weight, localMaskOnGridDest_.back()) ;
+        CTimer::get("computeTransformationMappingNonDistributed").suspend();  
+
+        CTimer::get("computeTransformationMappingConvert").resume();  
+        nbLocalIndexOnGridDest_.push_back(localMaskOnGridDest_.back().size()) ;
+        int clientRank=client->clientRank ;
+        {
+          SendingIndexGridSourceMap tmp;
+          localIndexToSendFromGridSource_.push_back(tmp) ;
+          SendingIndexGridSourceMap& src=localIndexToSendFromGridSource_.back() ;
+          CArray<int,1> arrayTmp ;
+          src.insert( pair<int,CArray<int,1> >(clientRank,arrayTmp)) ;
+          CArray<int,1>& array=src[clientRank] ;
+          array.resize(localSrc.size()) ;
+          for(int i=0;i< localSrc.size();++i) array(i)=localSrc[i]  ;    
+        }
+        {
+          RecvIndexGridDestinationMap tmp;
+          localIndexToReceiveOnGridDest_.push_back(tmp) ;
+          RecvIndexGridDestinationMap& dst=localIndexToReceiveOnGridDest_.back() ;
+          vector<pair<int,double> > vectTmp ;
+          dst.insert( pair<int,vector<pair<int,double> >  >(clientRank,vectTmp)) ;
+          vector<pair<int,double> >& vect=dst[clientRank] ;
+          vect.resize(localDst.size()) ;
+          for(int i=0;i< localDst.size();++i) vect[i]=pair<int,double>(localDst[i],weight[i])  ;      
+        }
+        CTimer::get("computeTransformationMappingConvert").suspend();  
+      }
+      else
+      {
+        CTimer::get("computeGlobalSourceIndex").resume();           
+        algo->computeGlobalSourceIndex(elementPosition,
+                                       gridSource_,
+                                       tmpGridDestination_,
+                                       globaIndexWeightFromSrcToDst);
+                                     
+        CTimer::get("computeGlobalSourceIndex").suspend();           
+        CTimer::get("computeTransformationMapping").resume();     
+        // Compute transformation of global indexes among grids
+        computeTransformationMapping(globaIndexWeightFromSrcToDst);
+        CTimer::get("computeTransformationMapping").suspend(); 
+      } 
       if (1 < nbNormalAlgos_)
       {
Index: /XIOS/trunk/src/transformation/grid_transformation_selector.cpp
===================================================================
--- /XIOS/trunk/src/transformation/grid_transformation_selector.cpp	(revision 1536)
+++ /XIOS/trunk/src/transformation/grid_transformation_selector.cpp	(revision 1537)
@@ -22,4 +22,5 @@
   CScalarAlgorithmExtractAxis::registerTrans();
   CScalarAlgorithmReduceDomain::registerTrans();
+  CScalarAlgorithmReduceScalar::registerTrans();
 
   //! Axis
@@ -29,4 +30,7 @@
   CAxisAlgorithmInverse::registerTrans();
   CAxisAlgorithmReduceDomain::registerTrans();
+  CAxisAlgorithmReduceAxis::registerTrans();
+  CAxisAlgorithmTemporalSplitting::registerTrans();
+  CAxisAlgorithmDuplicateScalar::registerTrans();
 
   //! Domain
@@ -35,4 +39,5 @@
   CDomainAlgorithmZoom::registerTrans();
   CDomainAlgorithmExpand::registerTrans();
+  CDomainAlgorithmReorder::registerTrans();
 }
 
Index: /XIOS/trunk/src/transformation/grid_transformation_selector.hpp
===================================================================
--- /XIOS/trunk/src/transformation/grid_transformation_selector.hpp	(revision 1536)
+++ /XIOS/trunk/src/transformation/grid_transformation_selector.hpp	(revision 1537)
@@ -51,4 +51,11 @@
   const std::vector<StdString>& getAuxInputs() const { return auxInputs_; }
   const std::vector<CGenericAlgorithmTransformation*>& getAlgos() const { return algoTransformation_; }
+  const std::map<int, int> getElementPositionInGridSrc2AxisPosition() const { return elementPositionInGridSrc2AxisPosition_ ;}
+  const std::map<int, int> getElementPositionInGridSrc2DomainPosition() const { return elementPositionInGridSrc2DomainPosition_ ;}
+  const std::map<int, int> getElementPositionInGridSrc2ScalarPosition() const { return elementPositionInGridSrc2ScalarPosition_ ;}
+  const std::map<int, int> getElementPositionInGridDst2AxisPosition() const { return elementPositionInGridDst2AxisPosition_ ;}
+  const std::map<int, int> getElementPositionInGridDst2DomainPosition() const { return elementPositionInGridDst2DomainPosition_ ;}
+  const std::map<int, int> getElementPositionInGridDst2ScalarPosition() const { return elementPositionInGridDst2ScalarPosition_ ;}
+
 
 protected:
Index: /XIOS/trunk/src/transformation/scalar_algorithm_reduce_domain.cpp
===================================================================
--- /XIOS/trunk/src/transformation/scalar_algorithm_reduce_domain.cpp	(revision 1536)
+++ /XIOS/trunk/src/transformation/scalar_algorithm_reduce_domain.cpp	(revision 1537)
@@ -46,4 +46,6 @@
    reduction_(0)
 {
+  algo->checkValid(scalarDestination, domainSource);
+  
   StdString op;
   switch (algo->operation)
@@ -76,4 +78,5 @@
 
   reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations[op]);
+  local = algo->local ;
 }
 
@@ -105,12 +108,32 @@
   TransformationWeightMap& transWeight = this->transformationWeight_[0];
 
-  int globalIndexSize = domainSrc_->ni_glo * domainSrc_->nj_glo;  
+  int ni_glo = domainSrc_->ni_glo ;
+  int nj_glo = domainSrc_->nj_glo ;
+  int nbDomainIdx ;
+  
+  if (local)
+  {
+      const CArray<int, 1>& i_index = domainSrc_-> i_index.getValue() ;
+      const CArray<int, 1>& j_index = domainSrc_-> j_index.getValue() ;
+      const CArray<bool,1>& localMask = domainSrc_-> localMask ;
+      int nbDomainIdx = i_index.numElements();
 
-  transMap[0].resize(globalIndexSize);
-  transWeight[0].resize(globalIndexSize, 1.0);
-  for (int idx = 0; idx < globalIndexSize; ++idx)
-  {     
-    transMap[0][idx] = idx;    
+      for (int idxDomain = 0; idxDomain < nbDomainIdx; ++idxDomain)
+      {
+        if (localMask(idxDomain))
+        { 
+          transMap[0].push_back(j_index(idxDomain)* ni_glo + i_index(idxDomain));
+          transWeight[0].push_back(1.0) ;
+        }
+      }
   }
+  else
+  {  
+    nbDomainIdx = ni_glo * nj_glo;
+    transMap[0].resize(nbDomainIdx);
+    transWeight[0].resize(nbDomainIdx, 1.0);
+    for (int idxDomain = 0; idxDomain < nbDomainIdx; ++idxDomain) transMap[0][idxDomain] = idxDomain;    
+  }
+  
 }
 
Index: /XIOS/trunk/src/transformation/scalar_algorithm_reduce_domain.hpp
===================================================================
--- /XIOS/trunk/src/transformation/scalar_algorithm_reduce_domain.hpp	(revision 1536)
+++ /XIOS/trunk/src/transformation/scalar_algorithm_reduce_domain.hpp	(revision 1537)
@@ -41,4 +41,5 @@
   static bool registerTrans();
 protected:
+  bool local ;
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
 
Index: /XIOS/trunk/src/transformation/scalar_algorithm_reduce_scalar.cpp
===================================================================
--- /XIOS/trunk/src/transformation/scalar_algorithm_reduce_scalar.cpp	(revision 1537)
+++ /XIOS/trunk/src/transformation/scalar_algorithm_reduce_scalar.cpp	(revision 1537)
@@ -0,0 +1,111 @@
+/*!
+   \file scalar_algorithm_reduce_scalar.cpp
+ 
+   \brief Algorithm for reduce an scalar to a scalar
+ */
+#include "scalar_algorithm_reduce_scalar.hpp"
+#include "scalar.hpp"
+#include "reduce_scalar_to_scalar.hpp"
+#include "grid.hpp"
+#include "grid_transformation_factory_impl.hpp"
+#include "reduction.hpp"
+
+
+namespace xios {
+CGenericAlgorithmTransformation* CScalarAlgorithmReduceScalar::create(CGrid* gridDst, CGrid* gridSrc,
+                                                                     CTransformation<CScalar>* transformation,
+                                                                     int elementPositionInGrid,
+                                                                     std::map<int, int>& elementPositionInGridSrc2ScalarPosition,
+                                                                     std::map<int, int>& elementPositionInGridSrc2AxisPosition,
+                                                                     std::map<int, int>& elementPositionInGridSrc2DomainPosition,
+                                                                     std::map<int, int>& elementPositionInGridDst2ScalarPosition,
+                                                                     std::map<int, int>& elementPositionInGridDst2AxisPosition,
+                                                                     std::map<int, int>& elementPositionInGridDst2DomainPosition)
+{
+  std::vector<CScalar*> scalarListDestP = gridDst->getScalars();
+  std::vector<CScalar*> scalarListSrcP  = gridSrc->getScalars();
+
+  CReduceScalarToScalar* reduceScalar = dynamic_cast<CReduceScalarToScalar*> (transformation);
+  int scalarDstIndex = elementPositionInGridDst2ScalarPosition[elementPositionInGrid];
+  int scalarSrcIndex = elementPositionInGridSrc2AxisPosition[elementPositionInGrid];
+
+  return (new CScalarAlgorithmReduceScalar(scalarListDestP[scalarDstIndex], scalarListSrcP[scalarSrcIndex], reduceScalar));
+}
+
+bool CScalarAlgorithmReduceScalar::registerTrans()
+{
+  CGridTransformationFactory<CScalar>::registerTransformation(TRANS_REDUCE_SCALAR_TO_SCALAR, create);
+}
+
+CScalarAlgorithmReduceScalar::CScalarAlgorithmReduceScalar(CScalar* scalarDestination, CScalar* scalarSource, CReduceScalarToScalar* algo)
+ : CScalarAlgorithmTransformation(scalarDestination, scalarSource),
+   reduction_(0)
+{
+  eliminateRedondantSrc_= false ;
+  if (algo->operation.isEmpty())
+    ERROR("CScalarAlgorithmReduceScalar::CScalarAlgorithmReduceScalar(CScalar* scalarDestination, CScalar* scalarSource, CReduceScalarToScalar* algo)",
+           << "Operation must be defined."
+           << "Scalar source " <<scalarSource->getId() << std::endl
+           << "Scalar destination " << scalarDestination->getId());
+  StdString op;
+  switch (algo->operation)
+  {
+    case CReduceScalarToScalar::operation_attr::sum:
+      op = "sum";
+      break;
+    case CReduceScalarToScalar::operation_attr::min:
+      op = "min";
+      break;
+    case CReduceScalarToScalar::operation_attr::max:
+      op = "max";
+      break;
+    case CReduceScalarToScalar::operation_attr::average:
+      op = "average";
+      break;
+    default:
+        ERROR("CScalarAlgorithmReduceScalar::CScalarAlgorithmReduceScalar(CScalar* scalarDestination, CScalar* scalarSource, CReduceScalarToScalar* algo)",
+         << "Operation is wrongly defined. Supported operations: sum, min, max, average." << std::endl
+         << "Scalar source " <<scalarSource->getId() << std::endl
+         << "Scalar destination " << scalarDestination->getId());
+
+  }
+  
+  if (CReductionAlgorithm::ReductionOperations.end() == CReductionAlgorithm::ReductionOperations.find(op))
+    ERROR("CScalarAlgorithmReduceScalar::CScalarAlgorithmReduceScalar(CScalar* scalarDestination, CScalar* scalarSource, CReduceScalarToScalar* algo)",
+       << "Operation '" << op << "' not found. Please make sure to use a supported one"
+       << "Scalar source " <<scalarSource->getId() << std::endl
+       << "Scalar destination " << scalarDestination->getId());
+
+  reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations[op]);
+}
+
+void CScalarAlgorithmReduceScalar::apply(const std::vector<std::pair<int,double> >& localIndex, const double* dataInput, CArray<double,1>& dataOut,
+                                         std::vector<bool>& flagInitial, bool ignoreMissingValue, bool firstPass)
+{
+  reduction_->apply(localIndex, dataInput, dataOut, flagInitial, ignoreMissingValue, firstPass);
+}
+
+void CScalarAlgorithmReduceScalar::updateData(CArray<double,1>& dataOut)
+{
+  reduction_->updateData(dataOut);
+}
+
+CScalarAlgorithmReduceScalar::~CScalarAlgorithmReduceScalar()
+{
+  if (0 != reduction_) delete reduction_;
+}
+
+void CScalarAlgorithmReduceScalar::computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs)
+{
+  this->transformationMapping_.resize(1);
+  this->transformationWeight_.resize(1);
+
+  TransformationIndexMap& transMap = this->transformationMapping_[0];
+  TransformationWeightMap& transWeight = this->transformationWeight_[0];
+
+  transMap[0].push_back(0);
+  transWeight[0].push_back(1.0);
+
+}
+
+}
Index: /XIOS/trunk/src/transformation/scalar_algorithm_reduce_scalar.hpp
===================================================================
--- /XIOS/trunk/src/transformation/scalar_algorithm_reduce_scalar.hpp	(revision 1537)
+++ /XIOS/trunk/src/transformation/scalar_algorithm_reduce_scalar.hpp	(revision 1537)
@@ -0,0 +1,57 @@
+/*!
+   \file scalar_algorithm_reduce_scalar.hpp
+   \brief Algorithm for reduce an scalar to a scalar
+ */
+#ifndef __XIOS_SCALAR_ALGORITHM_REDUCE_SCALAR_HPP__
+#define __XIOS_SCALAR_ALGORITHM_REDUCE_SCALAR_HPP__
+
+#include "scalar_algorithm_transformation.hpp"
+#include "transformation.hpp"
+
+namespace xios {
+
+class CScalar;
+class CReduceScalarToScalar;
+class CReductionAlgorithm;
+
+/*!
+  \class CScalarAlgorithmReduceScalar
+  Reducing an scalar to a scalar
+*/
+class CScalarAlgorithmReduceScalar : public CScalarAlgorithmTransformation
+{
+public:
+  CScalarAlgorithmReduceScalar(CScalar* scalarDestination, CScalar* scalarSource, CReduceScalarToScalar* algo);
+
+  virtual void apply(const std::vector<std::pair<int,double> >& localIndex,
+                     const double* dataInput,
+                     CArray<double,1>& dataOut,
+                     std::vector<bool>& flagInitial,
+                     bool ignoreMissingValue, bool firstPass);
+
+  virtual void updateData(CArray<double,1>& dataOut);
+  
+  virtual ~CScalarAlgorithmReduceScalar();
+
+  static bool registerTrans();
+protected:
+  void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
+
+protected:
+  CReductionAlgorithm* reduction_;
+
+private:
+
+  static CGenericAlgorithmTransformation* create(CGrid* gridDst, CGrid* gridSrc,
+                                                CTransformation<CScalar>* transformation,
+                                                int elementPositionInGrid,
+                                                std::map<int, int>& elementPositionInGridSrc2ScalarPosition,
+                                                std::map<int, int>& elementPositionInGridSrc2AxisPosition,
+                                                std::map<int, int>& elementPositionInGridSrc2DomainPosition,
+                                                std::map<int, int>& elementPositionInGridDst2ScalarPosition,
+                                                std::map<int, int>& elementPositionInGridDst2AxisPosition,
+                                                std::map<int, int>& elementPositionInGridDst2DomainPosition);
+};
+
+}
+#endif // __XIOS_SCALAR_ALGORITHM_REDUCE_SCALAR_HPP__
Index: /XIOS/trunk/src/transformation/scalar_algorithm_transformation.cpp
===================================================================
--- /XIOS/trunk/src/transformation/scalar_algorithm_transformation.cpp	(revision 1536)
+++ /XIOS/trunk/src/transformation/scalar_algorithm_transformation.cpp	(revision 1537)
@@ -70,12 +70,15 @@
     CArray<int,1>& jIndex = domainSrc_->j_index;
     int niGlo = domainSrc_->ni_glo;
-
+    CArray<bool,1>& localMask = domainSrc_ -> localMask ;
     CClientClientDHTInt::Index2VectorInfoTypeMap globalIndex2ProcRank;
     globalIndex2ProcRank.rehash(std::ceil(nIndexSize/globalIndex2ProcRank.max_load_factor()));
     for (int idx = 0; idx < nIndexSize; ++idx)
     {
-      globalIndex = jIndex(idx) * niGlo + iIndex(idx);
-      globalIndex2ProcRank[globalIndex].resize(1);
-      globalIndex2ProcRank[globalIndex][0] = clientRank;
+      if (localMask(idx))
+      {
+        globalIndex = jIndex(idx) * niGlo + iIndex(idx);
+        globalIndex2ProcRank[globalIndex].resize(1);
+        globalIndex2ProcRank[globalIndex][0] = clientRank;
+      }
     }
 
@@ -90,9 +93,14 @@
     CClientClientDHTInt::Index2VectorInfoTypeMap globalIndex2ProcRank;
     globalIndex2ProcRank.rehash(std::ceil(nIndexSize/globalIndex2ProcRank.max_load_factor()));
+    CArray<bool,1>& localMask = axisSrc_ -> mask ;
+   
     for (int idx = 0; idx < nIndexSize; ++idx)
     {
-      globalIndex = axisSrc_->index(idx);
-      globalIndex2ProcRank[globalIndex].resize(1);
-      globalIndex2ProcRank[globalIndex][0] = clientRank;
+      if (localMask(idx))
+      {
+        globalIndex = axisSrc_->index(idx);
+        globalIndex2ProcRank[globalIndex].resize(1);
+        globalIndex2ProcRank[globalIndex][0] = clientRank;
+      }
     }
 
Index: /XIOS/trunk/src/type/type_decl.cpp
===================================================================
--- /XIOS/trunk/src/type/type_decl.cpp	(revision 1536)
+++ /XIOS/trunk/src/type/type_decl.cpp	(revision 1537)
@@ -3,5 +3,5 @@
 #include "type_ref_impl.hpp"
 #include "type_specialisation.hpp"
-#include <string> ;
+#include <string>
 #include "date.hpp"
 #include "xios_spl.hpp"
